C--------------------------------------------------------------------
C     CALCULATE FUNCTION CONSTRAINT,RFACT AND WRFACT.
C--------------------------------------------------------------------
C
C
      SUBROUTINE CCALCON(ngsw,conF,conG,wrfact,rfact,connew,tnref,
     $     mref,nrefF,nrefG,FCAL,PROF,FOBS,SIGF,GCAL,GOBS,SIGG )
C
      IMPLICIT none
      integer ngsw,mref,nrefF,nrefG,iref
      real*8 conf,cong,wrfact,rfact,connew,tnref
      real*8 FCAL(2,mref),PROF(mref),FOBS(2,MREF),SIGF(MREF),
     $ GCAL(MREF),GOBS(mref),SIGG(MREF)
      real*8 bs1,bb1,bs2,bb2,er,ed2,eo2
      real*8 ei
C
      CONF=0.0
      CONG=0.0
      BS1=0.0
      BB1=0.0
      BS2=0.0
      BB2=0.0
C
C*** CALCULATE F-TYPE CONSTRAINT FUNCTION. ***
C
      DO 10 iref=1,nrefF
         ER=FCAL(1,iref)*PROF(iref)-FOBS(1,iref)
         EI=FCAL(2,iref)*PROF(iref)-FOBS(2,iref)
         ED2=ER*ER
     $       +EI*EI
         EO2=FOBS(1,iref)**2
     $       +FOBS(2,iref)**2
         CONF=CONF+ED2/SIGF(iref)
         BS1=BS1+ED2/SIGF(iref)
         BB1=BB1+EO2/SIGF(iref)
         BS2=BS2+DSQRT(ED2)
         BB2=BB2+DSQRT(EO2)
   10 CONTINUE
C
C     IF(NGSW.NE.0) GOTO 30
C
C*** CALCULATE G-TYPE CONSTRAINT FUNCTION. ***
C
      DO 20 iref=1,nrefG
         ED2=(GCAL(iref)-GOBS(iref))**2
         EO2=GOBS(iref)**2
         CONG=CONG+ED2/SIGG(iref)
         BS1=BS1+ED2/SIGG(iref)
         BB1=BB1+EO2/SIGG(iref)
         BS2=BS2+DSQRT(ED2)
         BB2=BB2+DSQRT(EO2)
   20 CONTINUE
C
C*** CALCULATE R-FACTOR AND COMBINED CONSTRAINT FUNCTION ***
C
C 30  
      WRFACT=DSQRT(BS1/BB1)
      RFACT=BS2/BB2
      CONNEW=(CONF+CONG)/tnref
C
      RETURN
      END
C
