C     Read density data, and additional constants and symmetry operations 
C     at the end of the density file 
C     this routine is called by the MECO program
C
      SUBROUTINE READD2(filden,masym,nasym,IASYM,RDEN,
     $   title,CELL,mpix,npix,nsym,ncen,nsub,IROT,RTRS,RSUB)

      integer*4 masym,nasym,ia
C     *** no of pixels along a,b,c axis; ix,iy,iz of pixels in asymm. unit ***
      integer NPIX(3),IASYM(3,masym)
C     *** symmetry operators ***
      integer IROT(3,3,48)
      real*8 RTRS(3,48),RSUB(3,4)
C     ***  density array
      real*8 RDEN(masym)
C     *** cell constants
      real*8 CELL(6)
      character filden*50,title*200
      integer i,j,k
C
1     OPEN(20,FILE=filden,FORM='FORMATTED',ERR=2,
     +     STATUS='OLD', ACCESS='SEQUENTIAL')
      goto 3
2       print *,'File not found, please give a new name:'
        read(*,'(a)') filden
        goto 1
1080  format(a)
1040  format(i7)
1090  format(2(3(I3,1X),G18.13,1x))

C     *** read title, number of pixels in asymm. unit and density array
3     READ(20,1080) title
      READ(20,1040) nasym
      if (nasym.GT.masym) then
	 print *,'maximal number of pixels in asymmetric unit is'
     $     ,masym
	 print *,'number of pixels in density file is',nasym
         CALL PROEND(
     $   'DIMENSION OVER FOR RDEN - TOO MANY POINTS IN ASYM. UNIT')
      endif
C     READ(20,1090,END=40) ((IASYM(i,ia),i=1,3),RDEN(ia),ia=1,nasym)
      do ia=1,nasym
        READ(20,*,END=40) (IASYM(I,ia),I=1,3),RDEN(ia)
      enddo

C     *** read cell constants, symmetry operators and pixel-resolution
      READ(20,'(6F10.5)') (CELL(i),i=1,6)
      READ(20,'(6I5)') (NPIX(i),i=1,3),nsym,ncen,nsub

      if (NPIX(1).GT.mpix.OR.NPIX(2).GT.mpix.OR.NPIX(3).GT.mpix)
     $  then
	write(*,'(a,3i4)') 'pixel resolution is ',(NPIX(i),i=1,3)
	write(*,'(a,3i4)') 'max. pixel resolution is ',mpix
	CALL PROEND('TOO HIGH RESOLUTION ALONG CELL AXES')
      endif

      READ(20,*)
     $    (((IROT(i,j,k),j=1,3),i=1,3),(RTRS(i,k),i=1,3),k=1,nsym)
      READ(20,*) ((RSUB(i,k),i=1,3),k=1,nsub)
C
C     *** if the components of the translation vectors are >= 1 then
C     *** the density file is in the old format with ITRS() and ISUB()
C     *** (integer pixel numbers) instead in real numbers 0=r<1 !
      do 10 is=1,nsym
      do 10 i=1,3
10       if (RTRS(i,is).ge.1) RTRS(i,is)=RTRS(i,is)/NPIX(i)
      do 11 is=1,nsub
      do 11 i=1,3
11       if (RSUB(i,is).ge.1) RSUB(i,is)=RSUB(i,is)/NPIX(i)
      close(20)
      return

   40 CLOSE(20)
      print *,'Number of density pixels in asym. unit should be',
     $   nasym
      print *,'Number of density pixels in asym. unit is ', ia
      CALL PROEND('Error reading density data.')
      return
      end
