C====================================================================
C
C     summen der elektronendichte um bestimmte Atome (kb) 22.11.95
C     (aus MECO-Programm)
C
C====================================================================
C     Parameter Masym (Maximalzahl der Punkte in der asymmetrischen 
C     Einheit) und Mpix (Maximalzahl der Pixel entlang einer Achse)
C     muessen hier und in allen Unterroutinen angepasst werden!
C
      PROGRAM sum
C
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (MASYM=275000,MPIX=129)
      PARAMETER (VPX1=0.0,VPY1=0.0,VPX2=1.6,VPY2=1.0)
      PARAMETER (WPX1=VPX1-0.05,WPY1=VPY1-0.2)
      PARAMETER (WPX2=VPX2-0.05,WPY2=VPY2-0.2)
      COMMON/DENS/DELC(0:MPIX,0:MPIX,0:MPIX),CELL(6),NPIX(3)
      COMMON/COOR/RDEO(MASYM),IASYM(3,MASYM),NASYM
      COMMON /CONST/TOTALE,RH,RK,RL,AS,BS,CS,GA,GB,GG,
     $              RDINT,FF1,FF2,POP,RTASYM,PI
      COMMON/SYMOP/IROT(3,3,48),ITRS(3,48),ISUB(3,4),NSYM,NCEN,NSUB
      COMMON/PARA/MAPT,NMX,NMY
      CHARACTER FILDEN*30,TITLE*70
      integer mx,my,mz,ieckx,iecky,ieckz,ilangx,ilangy,ilangz
      real*4  px,py,pz,wa,wb,wc
      real*8  rsum, wsum
C
 1000 FORMAT(2(/' '))
 2000 FORMAT(BN,I3)
 2010 FORMAT(A30)
 3010 FORMAT(/' ==============================================='
     $      //'   Summen von Elektronendichten um einen Punkt'
     $      //' ==============================================='
     $      //' INPUT DENSITY FILE''S NAME    = ')
 3020 FORMAT( ' ARE YOU SURE ?  YES(0)/NO(1) = ')
 3030 FORMAT(/' ******   WAIT A MOMENT ! DISK IS BUSY.   ******'
     $      //' TITLE : ',A)
C
C
C*** READ DENSITY FILE & RECONSTRUCT DENSITY ***
C
   10 WRITE(*,1000)
      WRITE(*,3010)
      READ(*,2010,ERR=10) FILDEN
      WRITE(*,3020)
      READ(*,2000,ERR=10) NYES
      IF(NYES.NE.0) GOTO 10
C
      OPEN(3,FILE=FILDEN,STATUS='OLD',ERR=10)
        READ(3,'(A70)') TITLE
        WRITE(*,3030) TITLE
        READ(3,'(I7)')  NASYM
	write(*,*) NASYM, ' Punkte in der asymmetrischen Einheit.'
        IF (NASYM.GT.MASYM) CALL PROEND('DIMENSION OVER FOR IASYM.')
        READ(3,'(2(3I5,F20.13))',END=30)
     $      ((IASYM(J,I),J=1,3),RDEO(I),I=1,NASYM)
   30   READ(3,'(6F10.5)') (CELL(I),I=1,6)
        READ(3,'(6I5)') (NPIX(I),I=1,3),NSYM,NCEN,NSUB
        IF (NPIX(1).GT.MPIX.OR.NPIX(2).GT.MPIX.OR.NPIX(3).GT.MPIX)
     $     CALL PROEND('DIMENSION OVER FOR DENSITY ARRAY DELC.')
        READ(3,'(12I5)')
     $      (((IROT(I,J,K),I=1,3),J=1,3),(ITRS(I,K),I=1,3),K=1,NSYM)
        READ(3,'(3I5)') ((ISUB(I,K),I=1,3),K=1,NSUB)
      CLOSE(3)
C
C     *** Konstanten berechnen: ***

      CALL PRECAL(0,0,0)

      rmax=rdeo(1)
      rmin=rmax
      do 39, i=1,NASYM
	rr=RDEO(i)
        if (rr .gt. rmax) rmax=rr
        if (rr .lt. rmin) rmin=rr 
39    continue
      print *,'Asymm. Einh. Maximum=', rmax
      print *,'Asym. Einh. Minimum=', rmin
      print *,'Einen Moment ...'

C     *** Ganze Zelle aus aymmm. einheit wiederherstellen: ***

      CALL RECNST
C
      rsum=0
      do 40, i=0,NPIX(1)-1
      do 40, j=0,NPIX(2)-1
      do 40, k=0,NPIX(3)-1
	rsum = rsum + delc(i,j,k)
40    continue
      print *,'Gesamte Elektronenzahl=',rsum * FF1

50    print *,'Um welchen Punkt soll integriert werden:'
      print *,'Gebe x,y,z in rel. Einheiten'
      read(*,'(3f12)') px,py,pz

      print *,'Zelle a,b,c, = ',cell(1),cell(2),cell(3)
      print *,'Pixel ',npix(1),npix(2),npix(3)
      print *,'Wieviele Angstrom entlang der Zellkanten soll'
      print *,'der Integrationswuerfel um den Punkt gross sein?'
      print *,'gebe a1,b1,c1 in Angstrom:'
      wa=0.0
      wb=0.0
      wc=0.0
      read(*,'(3f12)') wa,wb,wc
      mx=mod(nint(px*npix(1)),npix(1))
      my=mod(nint(py*npix(2)),npix(2))
      mz=mod(nint(pz*npix(3)),npix(3))
      print *,'Mitte (pixel) = ', mx,my,mz
      ilangx=nint( wa*npix(1)/cell(1) )
      ilangy=nint( wb*npix(2)/cell(2) )
      ilangz=nint( wc*npix(3)/cell(3) )
      print *,'Laenge Wuerfel (pix) = ', ilangx,ilangy,ilangz
      ieckx=mod( nint((2 + px - 0.5*wa/cell(1))*npix(1)), npix(1) )
      iecky=mod( nint((2 + py - 0.5*wb/cell(2))*npix(2)), npix(2) )
      ieckz=mod( nint((2 + pz - 0.5*wc/cell(3))*npix(3)), npix(3) )
      print *,'Ecke Wuerfel (pix) = ',ieckx,iecky,ieckz

      wsum = 0
      do 60 ix = 1,ilangx
      do 60 iy = 1,ilangy
      do 60 iz = 1,ilangz
	iix = mod( 2*npix(1) + ieckx + (ix-1), npix(1) ) 
	iiy = mod( 2*npix(2) + iecky + (iy-1), npix(2) ) 
	iiz = mod( 2*npix(3) + ieckz + (iz-1), npix(3) ) 
        wsum = wsum + delc( iix, iiy, iiz )
60    continue
      print *,'Summe Elektronenzahl = ',wsum * FF1
      print *,'Verhaeltnis zur gesamten Zelle:', wsum/rsum
      goto 50
C
C*** END OF PROCEDURE ***
C
      END
C
C--------------------------------------------------------------------
C     CALCULATE CONSTANTS
C--------------------------------------------------------------------
C
      SUBROUTINE PRECAL(JPH,JPK,JPL)
C
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (MASYM=275000,MPIX=129)
      COMMON/DENS/DELC(0:MPIX,0:MPIX,0:MPIX),CELL(6),NPIX(3)
      COMMON /CONST/TOTALE,RH,RK,RL,AS,BS,CS,GA,GB,GG,
     $              RDINT,FF1,FF2,POP,RTASYM,PI
C
      PI=2.0D+0*ACOS(0.0D+0)
      RAD=PI/180.0D+0
C
C*** CONSTANTS FOR RECIPROCAL SPACE ***
C
      CA=COS(RAD*CELL(4))
      CB=COS(RAD*CELL(5))
      CG=COS(RAD*CELL(6))
      SA=SIN(RAD*CELL(4))
      SB=SIN(RAD*CELL(5))
      SG=SIN(RAD*CELL(6))
      DA=CB*CG-CA
      DB=CG*CA-CB
      DG=CA*CB-CG
      DV=1.0D+0-CA*CA-CB*CB-CG*CG+2.0D+0*CA*CB*CG
      SV=SQRT(DV)
      AS=SA/(CELL(1)*SV)
      BS=SB/(CELL(2)*SV)
      CS=SG/(CELL(3)*SV)
      GA=2.0D+0*DA/(SB*SG)
      GB=2.0D+0*DB/(SG*SA)
      GG=2.0D+0*DG/(SA*SB)
      RH=DFLOAT(JPH)*AS
      RK=DFLOAT(JPK)*BS
      RL=DFLOAT(JPL)*CS
C
C*** CONSTANTS FOR DENSITY DATA ***
C
      AV=CELL(1)*CELL(2)*CELL(3)*SV
      RDINT=TOTALE/AV
      FF1=AV/DFLOAT(NPIX(1)*NPIX(2)*NPIX(3))
      FF2=TOTALE/FF1
C
      RETURN
      END
C
C--------------------------------------------------------------------
C     RECONSTRUCTS UNIT CELL DENSITY FROM ASYMMETRIC UNIT.
C--------------------------------------------------------------------
C
      SUBROUTINE RECNST
C
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (MPIX=129,MASYM=275000)
      COMMON/COOR/RDEO(MASYM),IASYM(3,MASYM),NASYM
      COMMON/DENS/DELC(0:MPIX,0:MPIX,0:MPIX),CELL(6),NPIX(3)
      COMMON/SYMOP/IROT(3,3,48),ITRS(3,48),ISUB(3,4),NSYM,NCEN,NSUB
C
      DO 10 IA=1,NASYM
         KX=IASYM(1,IA)
         KY=IASYM(2,IA)
         KZ=IASYM(3,IA)
      DO 10 IC=1,NCEN+1
      DO 10 IT=1,NSUB
         ISX=ISUB(1,IT)
         ISY=ISUB(2,IT)
         ISZ=ISUB(3,IT)
      DO 10 IS=1,NSYM
         NX=IROT(1,1,IS)*KX+IROT(1,2,IS)*KY+IROT(1,3,IS)*KZ+ITRS(1,IS)
         NY=IROT(2,1,IS)*KX+IROT(2,2,IS)*KY+IROT(2,3,IS)*KZ+ITRS(2,IS)
         NZ=IROT(3,1,IS)*KX+IROT(3,2,IS)*KY+IROT(3,3,IS)*KZ+ITRS(3,IS)
         IF (IC.EQ.2) THEN
            NX=-NX
            NY=-NY
            NZ=-NZ
         END IF
         NX=2*NPIX(1)+ISX+NX
         NX=MOD(NX,NPIX(1))
         NY=2*NPIX(2)+ISY+NY
         NY=MOD(NY,NPIX(2))
         NZ=2*NPIX(3)+ISZ+NZ
         NZ=MOD(NZ,NPIX(3))
         DELC(NX,NY,NZ)=RDEO(IA)
   10 CONTINUE
C
      RETURN
      END
C
C
C--------------------------------------------------------------------
C     TERMINATE PROGRAM BECAUSE ERROR OCCURED.
C--------------------------------------------------------------------
C
      SUBROUTINE PROEND(MESS)
C
      CHARACTER*(*) MESS
C
 3000 FORMAT(//' !!! ERROR !!! : ',A)
C
      WRITE(*,3000) MESS
C
      RETURN
      END
C
C  ============================================================
C
C In COMMON/RANG/ steht noch der Winkel THETA, den die zwei Achsen [001]
C und [110] mit einander bilden, oder auch [010] und [100]. Mit anderen
C Worten, man muss den Datensatz in einen Rechtwinkligen verwandeln, falls
C THETA von 90^0 abweicht. Bevor man zeichnet muss man mit Splines die
C Daten aendern. Es gibt wohl eine direkte Spline-Contour-Routine im IMSL-
C Paket.
C Ausserdem sollte man Schnitte zeichnen, was aber sehr leicht zu machen
C ist: den Datensatz mit RECNST komplettieren. Den Nullpunkt waehlen wie
C im Programm SFDAT, eine Richtung aus waehlen und dann zeichnen.
C Problem: moeglicherweise liegen auf der Richtung wenig direkte Punkte,
C so dass man einen "Tensorspline" machen muss.
C
C
C
C
C--------------------------------------------------------------------
C     PRODUCE FILE CONTAINING 2-dim MAP 
C--------------------------------------------------------------------
C
      SUBROUTINE ERGEBNIS
C
C     Ausgaberoutine fuer SURFER-Graphik, von P.Schiebel / K.Burger
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (MPIX=129)
      PARAMETER (RAD=3.14159265/180.0)
      COMMON/DENS/DELC(0:MPIX,0:MPIX,0:MPIX),CELL(6),NPIX(3)
      COMMON/PLAN/D(2*MPIX+1,2*MPIX+1)
      COMMON/RANG/THETA,VX,VY,DMAX,DMIN
      COMMON/PARA/MAPT,NMX,NMY
      COMMON/SCAL/LX,LY
      COMMON/AXIS/AXIS_X,AXIS_Y
      COMMON/RXRY/RX,RY
      CHARACTER AXIS_X*5,AXIS_Y*5
      character*30 name
C       MAPT = 1 | 2 | 3 | 4:  (110) | 100 | 010 | 001 Ebenen
C       MAPK =     1 | 2 | 3:          100 | 010 | 001 Ebenen
C       CELL(i)   = a,b,c,alpha,beta,gamma
C       NMX, NMY  = NPIX(i) = Anzahl Pixel (z.B. 32) bei Rekonstruktion
C       D(1..LX,1..LY) = 2-dim Karte
C       LX,LY     = Anzahl Pixel in 2-dim Karte (mit Ecken, z.B. 33)
C       THETA     = Winkel zwischen gewaehlten Achsen
C       VX,VY     = Gitterkonstanten entlang gew"ahlter Achsen
C       DMAX,DMIN = maximale/minimale Dichte

      write(*,*)
789   format(' Winkel theta zwischen Achsen ist ',f6.2,' Grad')
791   format(' X-Achse: ',A5,'    Y-Achse:',A5)
      write(*,789) theta/RAD
      write(*,791) AXIS_X,AXIS_Y

      is=0
      write(*,*) 'Soll die Karte mit den Gitterkonstanten skaliert werden',
     *  ' (0=ja, 1=nein) ?'
      read(*,'(BN,I3)') is

      if (theta/RAD.eq.90) then
	 print *, 'Die Achsen sind rechtwinklig, Sie koennen direkt'
     $      ,'eine GRID-Datei anlegen: (0=ja,1=nein)'
         iwas=0
         read(*,'(BN,I3)') iwas
      else
	 iwas=1
      endif
      if  (iwas.ne.0) goto 800
      
C     *** Ausgabe einer fertigen GRID-Datei fuer das SURFER-Programm ***
C     *** nur fuer rechten Winkel theta

      name='bild.grd'
      write(*,*) 'Name der Ausgabedatei fuer das '
     *     ,'SURFER-Programm ? (',name(1:10),') '
      read(*,'(A30)') name
      if (name(1:10).eq.'          ') name='bild.grd'
      write(*,*) 'Ausgabe in Datei ',name
      open(7,file=name,status='unknown')

      write(7,'(a4)') 'DSAA'
      write(7,'(I3,x,I3)') lx,ly
      write(7,'(a4,1x,f10.5)') '   0',vx
      write(7,'(a4,1x,f10.5)') '   0',vy
      write(7,'(f15.3,1x,f15.3)') Dmin,Dmax 
       
      do 100 iy=1,ly
         write(7,*)(D(ix,iy), ix=1,lx)
  100 continue

      close(7)
      return


C     ------------ ASCII Datei erzeugen -----------------------------

800   name='bild.txt'
      write(*,*) 'Name der Ausgabedatei fuer das SURFER-Programm ? (',
     *            name(1:10),') '
      read(*,'(A30)') name
      if (name(1:10).eq.'          ') name='bild.txt'
      write(*,*) 'Ausgabe in Datei ',name
      open(7,file=name,status='unknown')
      write(7,*) '     ',AXIS_X,'     ',AXIS_Y, '        Dichte'

C     *** Ausgabe einer ASCII-Datei fuer das SURFER-Programm 
C     *** fuer PC (WINDOWS-Version) 
C     *** Wenn die Zelle schief ist (theta nicht 90 Grad), so
C     *** werden die zum Rechteck fehlenden Dreiecke aufgefuellt,
C     *** spaeter wird automatisch interpoliert durch die GRID-Routine
C     *** des SURFER, die auf ein rechtwinkliges Gitter umrechnet.
C     *** Ausgabe einer ASCII-x-y-Dichte-Datei fuer das SURFER Programm
C
      rcos=cos(theta)
      rsin=sin(theta)
      vvx=vx/(lx-1)
      vvy=vy/(ly-1)
      do 200 iy=1,ly
      do 200 ix=1,lx
        rx = ix-1 + (iy-1)*rcos
        ry = (iy-1)*rsin
        if (is.eq.0) then
           write(7,99) rx*vvx, ry*vvy, D(ix,iy)
        else
           write(7,99) rx, ry, D(ix,iy)
        endif
200   continue
 99   format (f12.4,1x,f12.4,1x,f15.5)

      rx=lx-1+(ly-1)*rcos
      ry=(ly-1)*rsin
      rrx=abs(rx-(lx-1))
      if (theta/RAD.gt. 90) then
       xmin= (ly-1)*rcos
       xmax=lx-1.
      else
       xmin=0
       xmax=lx-1+(ly-1)*rcos
      endif

C     *** Rand auffuellen ***
      if (theta.ne.90*RAD) then
        do 110 i=1,int(rrx)
        do 110 j=1,ly
        x=lx-1+i+(j-1)*rcos
        y=(j-1)*rsin
          dd=D(i+1,j)
        if (x.gt.xmax) then
          x=x-(xmax-xmin)
          dd=D(lx-int(rrx)+i,j)
          endif
          if (is.eq.0) then
             write(7,99) x*vvx, y*vvy, dd
          else
             write(7,99) x, y, dd
          endif
110     continue
      if (theta/RAD.gt.90.) then
          write(7,99) 0,0, D(lx-int(rrx),1)
        else
        if (is.eq.0) then
            write(7,99) 0,ry*vvy, D(lx-int(rrx),ly)
        else
            write(7,99) 0,ry, D(lx-int(rrx),ly)
        endif
        endif
      endif     

      close(7)
      return

      end

C--------------------------------------------------------------------
